// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.ApiManagement.SmapiModels
{
    /// <summary>
    /// Certificate details.
    /// </summary>
    public partial class CertificateContract
    {
        private DateTime _expirationDate;
        
        /// <summary>
        /// Optional. Gets or sets Expiration date of the certificate.
        /// </summary>
        public DateTime ExpirationDate
        {
            get { return this._expirationDate; }
            set { this._expirationDate = value; }
        }
        
        private string _idPath;
        
        /// <summary>
        /// Optional. Gets or sets Certificate identifier path:
        /// /certificates/{certificateId}
        /// </summary>
        public string IdPath
        {
            get { return this._idPath; }
            set { this._idPath = value; }
        }
        
        private string _subject;
        
        /// <summary>
        /// Optional. Gets or sets Subject attribute of the certificate.
        /// </summary>
        public string Subject
        {
            get { return this._subject; }
            set { this._subject = value; }
        }
        
        private string _thumbprint;
        
        /// <summary>
        /// Optional. Gets or sets Thumbprint of the certificate.
        /// </summary>
        public string Thumbprint
        {
            get { return this._thumbprint; }
            set { this._thumbprint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CertificateContract class.
        /// </summary>
        public CertificateContract()
        {
        }
    }
}
