// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Batch;
using Microsoft.Azure.Management.Batch.Models;

namespace Microsoft.Azure.Management.Batch
{
    public static partial class BatchManagementClientExtensions
    {
        /// <summary>
        /// The Get Account Create Operation Status operation returns the
        /// status of the account creation operation. After calling an
        /// asynchronous operation, you can call this method to determine
        /// whether the operation has succeeded, failed, or is still in
        /// progress.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.IBatchManagementClient.
        /// </param>
        /// <param name='operationStatusLink'>
        /// Required. Location value returned by the BeginCreating operation.
        /// </param>
        /// <returns>
        /// Values returned by the Create operation.
        /// </returns>
        public static BatchAccountCreateResponse GetAccountCreateOperationStatus(this IBatchManagementClient operations, string operationStatusLink)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IBatchManagementClient)s).GetAccountCreateOperationStatusAsync(operationStatusLink);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Get Account Create Operation Status operation returns the
        /// status of the account creation operation. After calling an
        /// asynchronous operation, you can call this method to determine
        /// whether the operation has succeeded, failed, or is still in
        /// progress.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.IBatchManagementClient.
        /// </param>
        /// <param name='operationStatusLink'>
        /// Required. Location value returned by the BeginCreating operation.
        /// </param>
        /// <returns>
        /// Values returned by the Create operation.
        /// </returns>
        public static Task<BatchAccountCreateResponse> GetAccountCreateOperationStatusAsync(this IBatchManagementClient operations, string operationStatusLink)
        {
            return operations.GetAccountCreateOperationStatusAsync(operationStatusLink, CancellationToken.None);
        }
        
        /// <summary>
        /// The Get Delete Operation Status operation returns the status of the
        /// specified operation. After calling an asynchronous operation, you
        /// can call Get Delete Operation Status to determine whether the
        /// operation has succeeded, failed, or is still in progress.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.IBatchManagementClient.
        /// </param>
        /// <param name='operationStatusLink'>
        /// Required. Location value returned by the BeginDeleting operation.
        /// </param>
        /// <returns>
        /// A standard service response for long running operations.
        /// </returns>
        public static LongRunningOperationResponse GetAccountDeleteOperationStatus(this IBatchManagementClient operations, string operationStatusLink)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((IBatchManagementClient)s).GetAccountDeleteOperationStatusAsync(operationStatusLink);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// The Get Delete Operation Status operation returns the status of the
        /// specified operation. After calling an asynchronous operation, you
        /// can call Get Delete Operation Status to determine whether the
        /// operation has succeeded, failed, or is still in progress.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.Azure.Management.Batch.IBatchManagementClient.
        /// </param>
        /// <param name='operationStatusLink'>
        /// Required. Location value returned by the BeginDeleting operation.
        /// </param>
        /// <returns>
        /// A standard service response for long running operations.
        /// </returns>
        public static Task<LongRunningOperationResponse> GetAccountDeleteOperationStatusAsync(this IBatchManagementClient operations, string operationStatusLink)
        {
            return operations.GetAccountDeleteOperationStatusAsync(operationStatusLink, CancellationToken.None);
        }
    }
}
