// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.Azure.Management.Batch.Models;

namespace Microsoft.Azure.Management.Batch.Models
{
    /// <summary>
    /// Values returned by the ListActions operation.
    /// </summary>
    public partial class BatchAccountListActionsResponse : AzureOperationResponse, IEnumerable<AccountActions>
    {
        private IList<AccountActions> _actions;
        
        /// <summary>
        /// Optional. The collection of specialized actions for the provider.
        /// </summary>
        public IList<AccountActions> Actions
        {
            get { return this._actions; }
            set { this._actions = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BatchAccountListActionsResponse
        /// class.
        /// </summary>
        public BatchAccountListActionsResponse()
        {
            this.Actions = new LazyList<AccountActions>();
        }
        
        /// <summary>
        /// Gets the sequence of Actions.
        /// </summary>
        public IEnumerator<AccountActions> GetEnumerator()
        {
            return this.Actions.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of Actions.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
