// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the response to a Get request for Upgrade status of an Azure
    /// SQL Database Server.
    /// </summary>
    public partial class ServerUpgradeGetResponse : AzureOperationResponse
    {
        private System.DateTime? _scheduleUpgradeAfterTime;
        
        /// <summary>
        /// Optional. Gets the schedule time of the Azure SQL Database Server
        /// Upgrade.
        /// </summary>
        public System.DateTime? ScheduleUpgradeAfterTime
        {
            get { return this._scheduleUpgradeAfterTime; }
            set { this._scheduleUpgradeAfterTime = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. Gets the status of the Azure SQL Database Server Upgrade.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServerUpgradeGetResponse class.
        /// </summary>
        public ServerUpgradeGetResponse()
        {
        }
    }
}
