// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of a Service Tier Advisor.
    /// </summary>
    public partial class ServiceTierAdvisorProperties
    {
        private double? _activeTimeRatio;
        
        /// <summary>
        /// Optional. Gets the activeTimeRatio for service tier advisor.
        /// </summary>
        public double? ActiveTimeRatio
        {
            get { return this._activeTimeRatio; }
            set { this._activeTimeRatio = value; }
        }
        
        private double? _avgDtu;
        
        /// <summary>
        /// Optional. Gets or sets avgDtu for service tier advisor.
        /// </summary>
        public double? AvgDtu
        {
            get { return this._avgDtu; }
            set { this._avgDtu = value; }
        }
        
        private double _confidence;
        
        /// <summary>
        /// Optional. Gets or sets confidence for service tier advisor.
        /// </summary>
        public double Confidence
        {
            get { return this._confidence; }
            set { this._confidence = value; }
        }
        
        private string _currentServiceLevelObjective;
        
        /// <summary>
        /// Optional. Gets or sets currentServiceLevelObjective for service
        /// tier advisor.
        /// </summary>
        public string CurrentServiceLevelObjective
        {
            get { return this._currentServiceLevelObjective; }
            set { this._currentServiceLevelObjective = value; }
        }
        
        private System.Guid? _currentServiceLevelObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets currentServiceLevelObjectiveId for service
        /// tier advisor.
        /// </summary>
        public System.Guid? CurrentServiceLevelObjectiveId
        {
            get { return this._currentServiceLevelObjectiveId; }
            set { this._currentServiceLevelObjectiveId = value; }
        }
        
        private string _databaseSizeBasedRecommendationServiceLevelObjective;
        
        /// <summary>
        /// Optional. Gets or sets
        /// databaseSizeBasedRecommendationServiceLevelObjective for service
        /// tier advisor.
        /// </summary>
        public string DatabaseSizeBasedRecommendationServiceLevelObjective
        {
            get { return this._databaseSizeBasedRecommendationServiceLevelObjective; }
            set { this._databaseSizeBasedRecommendationServiceLevelObjective = value; }
        }
        
        private System.Guid? _databaseSizeBasedRecommendationServiceLevelObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets
        /// databaseSizeBasedRecommendationServiceLevelObjectiveId for service
        /// tier advisor.
        /// </summary>
        public System.Guid? DatabaseSizeBasedRecommendationServiceLevelObjectiveId
        {
            get { return this._databaseSizeBasedRecommendationServiceLevelObjectiveId; }
            set { this._databaseSizeBasedRecommendationServiceLevelObjectiveId = value; }
        }
        
        private string _disasterPlanBasedRecommendationServiceLevelObjective;
        
        /// <summary>
        /// Optional. Gets or sets
        /// disasterPlanBasedRecommendationServiceLevelObjective for service
        /// tier advisor.
        /// </summary>
        public string DisasterPlanBasedRecommendationServiceLevelObjective
        {
            get { return this._disasterPlanBasedRecommendationServiceLevelObjective; }
            set { this._disasterPlanBasedRecommendationServiceLevelObjective = value; }
        }
        
        private System.Guid? _disasterPlanBasedRecommendationServiceLevelObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets
        /// disasterPlanBasedRecommendationServiceLevelObjectiveId for service
        /// tier advisor.
        /// </summary>
        public System.Guid? DisasterPlanBasedRecommendationServiceLevelObjectiveId
        {
            get { return this._disasterPlanBasedRecommendationServiceLevelObjectiveId; }
            set { this._disasterPlanBasedRecommendationServiceLevelObjectiveId = value; }
        }
        
        private double? _maxDtu;
        
        /// <summary>
        /// Optional. Gets or sets maxDtu for service tier advisor.
        /// </summary>
        public double? MaxDtu
        {
            get { return this._maxDtu; }
            set { this._maxDtu = value; }
        }
        
        private double? _maxSizeInGB;
        
        /// <summary>
        /// Optional. Gets or sets maxSizeInGB for service tier advisor.
        /// </summary>
        public double? MaxSizeInGB
        {
            get { return this._maxSizeInGB; }
            set { this._maxSizeInGB = value; }
        }
        
        private double? _minDtu;
        
        /// <summary>
        /// Optional. Gets or sets minDtu for service tier advisor.
        /// </summary>
        public double? MinDtu
        {
            get { return this._minDtu; }
            set { this._minDtu = value; }
        }
        
        private System.DateTime? _observationPeriodEnd;
        
        /// <summary>
        /// Optional. Gets the observation period start.
        /// </summary>
        public System.DateTime? ObservationPeriodEnd
        {
            get { return this._observationPeriodEnd; }
            set { this._observationPeriodEnd = value; }
        }
        
        private System.DateTime? _observationPeriodStart;
        
        /// <summary>
        /// Optional. Gets the observation period start.
        /// </summary>
        public System.DateTime? ObservationPeriodStart
        {
            get { return this._observationPeriodStart; }
            set { this._observationPeriodStart = value; }
        }
        
        private string _overallRecommendationServiceLevelObjective;
        
        /// <summary>
        /// Optional. Gets or sets overallRecommendationServiceLevelObjective
        /// for service tier advisor.
        /// </summary>
        public string OverallRecommendationServiceLevelObjective
        {
            get { return this._overallRecommendationServiceLevelObjective; }
            set { this._overallRecommendationServiceLevelObjective = value; }
        }
        
        private System.Guid? _overallRecommendationServiceLevelObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets overallRecommendationServiceLevelObjectiveId
        /// for service tier advisor.
        /// </summary>
        public System.Guid? OverallRecommendationServiceLevelObjectiveId
        {
            get { return this._overallRecommendationServiceLevelObjectiveId; }
            set { this._overallRecommendationServiceLevelObjectiveId = value; }
        }
        
        private IList<SloUsageMetric> _serviceLevelObjectiveUsageMetrics;
        
        /// <summary>
        /// Optional. Gets or sets serviceLevelObjectiveUsageMetrics for the
        /// service tier advisor.
        /// </summary>
        public IList<SloUsageMetric> ServiceLevelObjectiveUsageMetrics
        {
            get { return this._serviceLevelObjectiveUsageMetrics; }
            set { this._serviceLevelObjectiveUsageMetrics = value; }
        }
        
        private string _usageBasedRecommendationServiceLevelObjective;
        
        /// <summary>
        /// Optional. Gets or sets
        /// usageBasedRecommendationServiceLevelObjective for service tier
        /// advisor.
        /// </summary>
        public string UsageBasedRecommendationServiceLevelObjective
        {
            get { return this._usageBasedRecommendationServiceLevelObjective; }
            set { this._usageBasedRecommendationServiceLevelObjective = value; }
        }
        
        private System.Guid? _usageBasedRecommendationServiceLevelObjectiveId;
        
        /// <summary>
        /// Optional. Gets or sets
        /// usageBasedRecommendationServiceLevelObjectiveId for service tier
        /// advisor.
        /// </summary>
        public System.Guid? UsageBasedRecommendationServiceLevelObjectiveId
        {
            get { return this._usageBasedRecommendationServiceLevelObjectiveId; }
            set { this._usageBasedRecommendationServiceLevelObjectiveId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServiceTierAdvisorProperties
        /// class.
        /// </summary>
        public ServiceTierAdvisorProperties()
        {
            this.ServiceLevelObjectiveUsageMetrics = new LazyList<SloUsageMetric>();
        }
    }
}
