// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// This specifies the new (larger) size of the Data Disk created using a
    /// VM Image. The DataDiskConfiguration element is only available using
    /// version 2014-10-01 or higher.
    /// </summary>
    public partial class DataDiskConfiguration
    {
        private string _diskName;
        
        /// <summary>
        /// Optional. The Name of the DataDiskConfiguration being referenced
        /// to. The Name element is only available using version 2014-10-01 or
        /// higher.
        /// </summary>
        public string DiskName
        {
            get { return this._diskName; }
            set { this._diskName = value; }
        }
        
        private int? _resizedSizeInGB;
        
        /// <summary>
        /// Optional. This specifies the new (larger) size of the
        /// DataVirtualHardDisk created using a VM Image. The ResizedSizeInGB
        /// element is only available using version 2014-10-01 or higher.
        /// </summary>
        public int? ResizedSizeInGB
        {
            get { return this._resizedSizeInGB; }
            set { this._resizedSizeInGB = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DataDiskConfiguration class.
        /// </summary>
        public DataDiskConfiguration()
        {
        }
    }
}
