// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.WebSites.Models
{
    /// <summary>
    /// The Authentication / Authorization settings of a web site.
    /// </summary>
    public partial class SiteAuthSettings
    {
        private string _aADClientId;
        
        /// <summary>
        /// Optional. Gets or sets the OpenID Connection client_id value for
        /// the web site.
        /// </summary>
        public string AADClientId
        {
            get { return this._aADClientId; }
            set { this._aADClientId = value; }
        }
        
        private string _openIdIssuer;
        
        /// <summary>
        /// Optional. Gets or sets the OpenID Connect issuer URL value for the
        /// web site.
        /// </summary>
        public string OpenIdIssuer
        {
            get { return this._openIdIssuer; }
            set { this._openIdIssuer = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the SiteAuthSettings class.
        /// </summary>
        public SiteAuthSettings()
        {
        }
    }
}
